/* global tinymce */
tinymce.PluginManager.add( 'searchEntities', function( editor ) {
	
	// Register a command so that it can be invoked by using tinyMCE.activeEditor.execCommand( 'WP_Link' );
	editor.addCommand( 'WP_Search_Entities', function() {
		
		if ( !editor.selection.isCollapsed() ) {
			//alert('Send selected text to web service yeah:\n\n'+editor.selection.getContent());
			jQuery('#wp-content-editor-container').css( {"border": "1px solid yellow"});
			// todo: send and receive text
			
			var request;
			
			var scanningIndicator = jQuery('<div class="referScanningIndicator" style="position: absolute; bottom: -71px; left: 0; width: 100%; height: 30px; background: rgba(255, 251, 204, 0.8); color: #666; text-align: center; padding-top: 4px; font-weight: bold;"></div>');
			var closeIndicator = jQuery('<div style="position: absolute; right: 20px; top: 4px; font-height: 18px; cursor: pointer;">x</div>');
				closeIndicator.click(function() {
					request.abort();
					jQuery('.referScanningIndicator, .referScanningBlocker').remove();
					jQuery('#wp-content-editor-container').css({"border": "none"});
				});
			scanningIndicator.append('<span class="referMessage">Scanning Text ..</span>');
			scanningIndicator.append(closeIndicator);
			jQuery('#wp-content-editor-tools').append(scanningIndicator);
			
			var scanningBlocker = jQuery('<div class="referScanningBlocker" style="background: rgba(180, 180, 180, 0.2); position: absolute; top: 0px; height: 100%; width: 100%; z-index: 999;"></div>');
				scanningBlocker.appendTo(jQuery('#wp-content-editor-container'));
			
			request = jQuery.ajax({
				url: refer_plugin_url + "proxy.php?services/annotate/x?input="+ encodeURIComponent(editor.selection.getContent()),
				crossDomain: true,
				beforeSubmit: function() {
					
				}
			})
			.done(function(data) {
				
				if (data.error) {
					jQuery('.referScanningIndicator').css({
						backgroundColor: 'rgba(191, 30, 36, 0.6)',
						color: '#fff'
					}).children('.referMessage').text(data.message);
				}
				
				editor.selection.setContent(data.annotation);
				jQuery('#wp-content-editor-container').css( {"border": "none"});
				jQuery('.referScanningIndicator, .referScanningBlocker').remove();
			})
			.fail(function() {
				jQuery('#wp-content-editor-container').css( {"border": "1px solid red"});
				jQuery('.referScanningIndicator').css({
					backgroundColor: 'rgba(191, 30, 36, 0.6)',
					color: '#fff'
				}).children('.referMessage').text('Text could not be scanned.');
				jQuery('.referScanningBlocker').remove();
			})
			.always(function() {
				//
			});		
			
		} else {
			alert('Please select some text.');
		}

	});

	// WP default shortcut
	//editor.addShortcut( 'alt+shift+a', '', 'WP_Search_Entities' );

	editor.addButton( 'searchEntities', {
		id: 'searchEntitiesButton',
		icon: 'searchEntities',
		tooltip: 'Scan for Entities',
		shortcut: 'Alt+Shift+S',
		cmd: 'WP_Search_Entities'
	});

	editor.addMenuItem( 'link', {
		icon: 'link',
		text: 'Insert link',
		shortcut: 'Alt+Shift+A',
		cmd: 'WP_Entity_Link',
		stateSelector: 'a[href]',
		context: 'insert',
		prependToContext: true
	});
});
