<?php
/************************************
* refer Editor 
* > Functions
************************************/

function refer_add_editor_scripts() {
        wp_register_style( 'refer_toolbar_style', plugin_dir_url( __FILE__ ).'navigator-editor-toolbar.css');
        wp_enqueue_style( 'refer_toolbar_style' );

        if ( get_option('refer_annotation_interface') == 'inline' ) {
        	wp_register_style( 'refer_inline_suggestions', plugin_dir_url( __FILE__ ).'navigator-editor-inline.css');
        	wp_enqueue_style( 'refer_inline_suggestions' );
        } else {
        	wp_register_style( 'refer_suggestions', plugin_dir_url( __FILE__ ).'navigator-editor.css');
        	wp_enqueue_style( 'refer_suggestions' );
        }
        
        
        echo '<script type="text/javascript">
			/* <![CDATA[ */
        	var refer_base_url = "'.site_url().'";
			var refer_plugin_url = "'.plugins_url( '/', dirname(__FILE__) ).'";
			var refer_api_key_length = '.strlen(get_option( "refer_api_key" )).';
			var refer_initial_entity = "'.get_option( "refer_initial_entity" ).'";
			var refer_word_limit = parseInt("'.get_option( "refer_word_limit" ).'");
			var refer_annotation_interface = "'.get_option( "refer_annotation_interface" ).'";
			/* ]]> */
		</script>';

		if ( get_option('refer_annotation_interface') == 'inline' ) {
			wp_enqueue_script( 'refer_circleMenu', plugin_dir_url( __FILE__ ).'js/lib/jquery.circleMenu.js' );
			wp_enqueue_script( 'refer_donutchart', plugin_dir_url( __FILE__ ).'js/lib/jquery.donutchart.js' );
		}
		
}

function refer_add_editor_buttons() {
   // Only add hooks when the current user has permissions AND is in Rich Text editor mode
   if ( ( current_user_can('edit_posts') || current_user_can('edit_pages') ) && get_user_option('rich_editing') ) {
     add_action( 'wp_footer', 'my_plugin_dialog' );
     add_filter("mce_external_plugins", "refer_register_tinymce_plugins");
     add_filter('mce_buttons', 'refer_register_buttons');
   }
}
 
function refer_register_buttons($buttons) {
   array_push($buttons, "separator", "linkEntity", "unlinkEntity", "searchEntities");
   return $buttons;
}
 
function refer_register_tinymce_plugins($plugin_array) {
   
    if ( get_option('refer_annotation_interface') == 'inline' ) {
    	$plugin_array['linkEntitiesInline'] = plugins_url('/js/tinymce-linkEntities-inline.js',__file__);
    } else {
    	$plugin_array['linkEntities'] = plugins_url('/js/tinymce-linkEntities.js',__file__);
    }
   
    $plugin_array['searchEntities'] = plugins_url('/js/tinymce-searchEntities.js',__file__);
    return $plugin_array;
}

function plugin_mce_css( $mce_css ) {
	if ( ! empty( $mce_css ) )
		$mce_css .= ',';

	// add current time to prevent caching problems
	if ( get_option('refer_annotation_interface') == 'inline' ) {
		$mce_css .= plugins_url( 'navigator-editor-inline.css', __FILE__ ). '?r=' .time();
	} else {
		$mce_css .= plugins_url( 'navigator-editor.css', __FILE__ ).'?r='. time();
	}
	
	return $mce_css;
}

function my_plugin_dialog() { 
	?>
	<div style="display:none;">
		<form id="my_plugin_dialog" tabindex="-1" action="">
			<div>
				<input type="text" name="foo" />
			</div>
			<div>
				<input type="submit" class="button-primary" value="Go" />
			</div>
		</form>
	</div>
	<?php
}

function refer_add_updateservice( $post_id ) {
	
	// If post is an autosave or moved to trash, return
	
	$post = get_post($post_id);
    if(wp_is_post_autosave( $post_id ) || wp_is_post_revision( $post_id ) || $post->post_status == 'trash' || $post->post_status == 'auto-draft' || $post->post_status == 'draft' || $post->post_status == 'pending'){
            return $post_id;
    }
	
	$post_url = get_permalink( $post_id );
	$api_key =  get_option('refer_api_key');
	$base_url = site_url();
	$post_title = get_the_title( $post_id );
	$clean_post_title = urlencode($post_title);
	
	$ch = curl_init();
	
	curl_setopt($ch, CURLOPT_URL, "http://apps.yovisto.com/refer-rest/services/update/x?article=". $post_url ."&title=". $clean_post_title ."&ak=". $api_key ."&baseurl=". $base_url );
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

	curl_exec($ch);
	
	curl_close($ch);
	
}

function refer_add_deleteservice( $post_id ) {
	
	$post = get_post($post_id);
	
	if( wp_is_post_revision( $post_id ) ){
        return $post_id;
	}
	
	$post_url = get_permalink( $post_id );
	$api_key =  get_option('refer_api_key');
	$base_url = site_url();
	
	$ch = curl_init();
	
	curl_setopt($ch, CURLOPT_URL, "http://apps.yovisto.com/refer-rest/services/delete/x?article=". $post_url ."&ak=". $api_key ."&baseurl=". $base_url );
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

	curl_exec($ch);
	
	curl_close($ch);
	
}


?>