/************************************
* refer Entity Tooltips
************************************/

// use jQuery in noConflict mode

jQuery(document).ready(function($) {
	
	$('.entityLink').hover(function() {
		if ( $(this).children('.entityTooltip').length != 0 ) {
			$(this).children('.entityTooltip').show();
		} else {
			
			var entityTooltip = $('<div class="entityTooltip" data-category="'+ $(this).attr('data-category') +'"></div>');
			
			// Add Elements
			var hoverHelper = $('<div class="entityHoverHelper"></div>');
			var depictionElem = $('<img class="entityTooltipDepiction" src="'+ $(this).attr('data-thumbnail') +'"></img>');
			if ($(this).attr('title')) {
				var entityLabel = $(this).attr('title');
			} else {
				var entityLabel = $(this).attr('data-label');
			}
			
			$(this).attr('title', '');
			
			var labelElem = $('<div class="entityTooltipLabel">'+ entityLabel +'</div>');
			var abstractElem = $('<div class="entityTooltipAbstract"></div>');
			var miscElem = $('<table class="entityTooltipMisc"></table>');
			
			entityTooltip.append(hoverHelper, depictionElem, labelElem, abstractElem, miscElem);
			
			// Load Content
			var requestUrl = refer_plugin_url + "proxy.php?services/association/x?resource=" + $(this).attr('resource'); /* DEPLOYMENT */ 
			
			jQuery.ajax({
				url: requestUrl
			}).done( function (data) {
				
				abstractElem.text(data.activeEntity.abstract);
				
				for (var i=0; i < data.activeEntity.infos.length; i++) {
					var tableRow = $('<tr></tr>');
					var propertyKey = $('<td class="propertyKey">'+ data.activeEntity.infos[i].property +'</td>');
					var propertyValue = $('<td></td>');
					var miscLink = $('<div class="miscLink" data-uri="'+ data.activeEntity.infos[i].iri +'">'+ data.activeEntity.infos[i].label +'</div>').click(function(evt) {
						var uri = $(this).attr('data-uri');
						$('body,html').animate({
							scrollTop: 0
						}, 800, function() {
							$('#refer-plugin .smn-inner').slideDown(200, function() {
								$('body > .smn-entity').remove();
								$('.smn-entity img, .smn-entity-depiction img').centerImage();
								$('svg').fadeIn(0);
								resizeRelationBrowser();
								$('#refer-plugin .smn-tab[data-tabcontent="relation-browser"]').click();
								loadData(uri, true);
							});
						});
						evt.stopPropagation();
						evt.preventDefault();
					}).appendTo(propertyValue);
					tableRow.append(propertyKey, propertyValue);
					miscElem.append(tableRow);
					if (i >= 5) {
						return;
					}
				}
								
			}).fail( function (data) {
				//console.log(data);
			});
			
			$(this).append(entityTooltip);
			
		}		
	}, function() {
		$(this).children('.entityTooltip').hide();
	}).click(function(evt) {
		if ($(evt.target).hasClass('entityLink')) {
			var uri = $(this).attr('resource');
			$('body,html').animate({
				scrollTop: 0
			}, 800, function() {
				$('#refer-plugin .smn-inner').slideDown(200, function() {
					$('body > .smn-entity').remove();
					$('.smn-entity img, .smn-entity-depiction img').centerImage();
					$('svg').fadeIn(0);
					resizeRelationBrowser();
					$('#refer-plugin .smn-tab[data-tabcontent="relation-browser"]').click();
					loadData(uri, true);
				});
			});
		}
	});

});
