/************************************
* refer Main JS
************************************/

var maxHistoryItems = 8;

var currentData;
var originTimelineData;
var currentTimelineData;
var entityHistory = [];

// use jQuery in noConflict mode
jQuery(document).ready(function($) {
	
	$('body').prepend('<div id="refer-placeholder"></div>');
	
	$('.smn-tabcontent.relation-browser').show();
	
	$('#refer-plugin .smn-handle').click(function() {
		$(this).toggleClass('active');
		
		$('#refer-plugin .smn-inner').slideToggle(200, function() {
			$('body > .smn-entity').remove();
			$('.smn-entity img, .smn-entity-depiction img').centerImage();
			$('#refer-plugin svg').fadeToggle(0);
			resizeRelationBrowser();
		});
	});
	
	$('#refer-plugin .smn-tab').click(function() {
		$('#refer-plugin .smn-tab').removeClass('active');
		$(this).addClass('active');
		$('#refer-plugin .smn-tabcontent').hide();
		$('#refer-plugin .smn-tabcontent.'+ $(this).attr('data-tabcontent') ).show();
		resizeRelationBrowser();
		if ( $(this).attr('data-tabcontent') == 'timeline' && timeline ) {
			timeline.moveTo('1900-01-01', {animate: true});
		}
		$('.smn-entity img, .smn-entity-depiction img').centerImage();
		
	});
	
	$('#refer-plugin').hover(function() {
		$('body').css('overflow', 'hidden');
	}, function() {
		$('body').css('overflow', 'auto');
	});
	
	/* Load Dummy Data */
    // find the first entity on the page
    var entityLinks = jQuery(".entityLink");
    if (entityLinks.size()>0){        
        loadData(entityLinks.first().attr("resource"));
    }else{
        loadData(refer_initial_entity);
    }
    
    loadTimelineData();
	
});

jQuery(window).resize(function() {
	jQuery('body > .smn-entity').remove();
	jQuery('.smn-entity img, .smn-entity-depiction img').centerImage();
	
	jQuery("#refer-plugin svg").css({
		width: jQuery("#refer-plugin .smn-content").width() + "px",
		height: jQuery("#refer-plugin .smn-content").outerHeight() + "px"
	});
	
	resizeRelationBrowser();
	
});

function loadData( iri, ignoreHistory ) {
	
	jQuery('.smn-working-indicator').show();
	
	var requestUrl = refer_plugin_url + "proxy.php?services/association/x?resource=" + iri; /* DEPLOYMENT */ 

	jQuery.ajax({
		url: requestUrl,
		crossDomain: true
	}).done( function (data) {
		
		if ( data.error == "1" ) {
			alert("Error in refer Plugin: "+ data.message);
		} else {
			currentData = data;
			
			if ( !ignoreHistory && currentData.activeEntity.iri ) {
				var historyItem = {
						iri: currentData.activeEntity.iri,
						label: currentData.activeEntity.label
				};
				
				if (entityHistory.length > maxHistoryItems) {
					var cleanedHistory = entityHistory.slice(-maxHistoryItems);
					entityHistory = cleanedHistory;
				}
				
				entityHistory.push(historyItem);
			}
			
			buildInterface();
		}
		
		
	}).fail( function (data) {
		if ( data.error == "1" ) {
			alert("Error in refer Plugin: "+ data.message);
		}
	});
}

var entitiesPerPage = 21;
var entitiesPerLine = 3;

function buildInterface() {
	
	// Clean Up
	clearTimeout(delayTo);
	
	clearRaphael();
	
	jQuery('body > .connectionLabel').remove();
	jQuery('body > .smn-entity').remove();
	jQuery('#refer-plugin svg').css('z-index', -1);
	jQuery('.smn-entity').css('background-color', '');
	jQuery('.smn-entity').removeClass('active');
	jQuery('.smn-entity').removeClass('inactive');
	jQuery('.smn-relation-browser-breadcrumbs').empty();
	jQuery('.smn-entity-depiction img').css('opacity', '0');
    jQuery('.smn-relation-category-entities .smn-scroll-container, .smn-relation-category-pagination').empty();
    jQuery('.smn-scroll-container').css({
		top: 0 + 'px'
	});
    
    jQuery('.smn-tabcontent.relation-browser .smn-notification').remove();
	
	// Set active entity
	jQuery('.relation-browser .smn-result').attr('data-category', currentData.activeEntity.category);
	jQuery('.relation-browser .smn-result').attr("data-iri", currentData.activeEntity.iri);
	jQuery('.relation-browser .smn-current-entity .smn-entity-depiction img').attr( "src", currentData.activeEntity.depiction );
	jQuery('.relation-browser .smn-current-entity .smn-entity-title').text( currentData.activeEntity.label );
	if (currentData.activeEntity.abstract) {
		jQuery('.relation-browser .smn-current-entity .smn-entity-abstract').text( currentData.activeEntity.abstract );
	} else {
		jQuery('.relation-browser .smn-current-entity .smn-entity-abstract').text('');
	}
	jQuery('.relation-browser .smn-current-entity .smn-entity-references a').attr( "href", currentData.activeEntity.iri ).text( 'DBpedia: ' + currentData.activeEntity.label );

	// Set breadcrumbs
	for ( var i=0; i<entityHistory.length; i++ ) {
		
		if (entityHistory[i].iri != 'undefined') {
			var breadcrumb = jQuery('<div class="breadcrumbItem" data-iri="'+ entityHistory[i].iri +'">'+ entityHistory[i].label +'</div>');
			breadcrumb.click(function() {
				loadData( jQuery(this).attr('data-iri'), true );
			});
			jQuery('.smn-relation-browser-breadcrumbs').append(breadcrumb);
			
			if ( i < entityHistory.length -1 ) {
				var divider = jQuery('<div class="breadcrumb-divider">></div>');
				jQuery('.smn-relation-browser-breadcrumbs').append(divider);
			}
		}
	}
    
	// Set Related Articles
	jQuery('.relation-browser .smn-found-articles-count').text( currentData.relatedArticles.length );
    jQuery('.relation-browser .smn-found-articles-list').empty();
    
    if (refer_api_key_length < 2) {
		var notification = jQuery('<div class="smn-notification">Please login to Wordpress and provide an API Key in Settings > Smart Media Navigator</div>');
		jQuery('.smn-tabcontent.relation-browser').append(notification);
		return false;
	}
    
    for ( var i=0; i<currentData.relatedArticles.length; i++ ) {
		var articleNumber = i+1;
		var articleElement = jQuery('<a href="'+ currentData.relatedArticles[i].url +'" class="smn-article"><span class="smn-article-id">#'+ articleNumber +'</span> '+ currentData.relatedArticles[i].title +'</a>');
		jQuery('.relation-browser .smn-found-articles-list').append(articleElement);
	}

	// Set Related Entities in Relation Browser
	var cntPerson = 0;
	var cntPersonPage = 0;
	var cntPlace = 0;
	var cntPlacePage = 0;
	var cntEvent = 0;
	var cntEventPage = 0;
	var cntThing = 0;
	var cntThingPage = 0;
	
	if ( jQuery.isEmptyObject(currentData.relatedEntities) ) {
		var notification = jQuery('<div class="smn-notification">No related terms found.</div>');
		jQuery('.smn-tabcontent.relation-browser').append(notification);
	}
	
	for ( var key in currentData.relatedEntities ) {
		var entityElement = jQuery('<div class="smn-entity" data-iri="'+ key +'"></div>');
        
		var entityWrapper = jQuery('<div class="smn-entity-content"></div>');
		var entityDepiction = jQuery('<img src="'+ currentData.relatedEntities[key].depiction +'" />');
		var entityLabel = jQuery('<div class="smn-entity-label"><div>'+ currentData.relatedEntities[key].label +'</div></div>');
		
		var pageAnchorContainer = jQuery('<div class="smn-page-anchor-container"></div>');
		pageAnchorContainer.append('<div class="smn-page-anchor-category" data-category="Person"></div>');
		pageAnchorContainer.append('<div class="smn-page-anchor-category" data-category="Place"></div>');
		pageAnchorContainer.append('<div class="smn-page-anchor-category" data-category="Thing"></div>');
		pageAnchorContainer.append('<div class="smn-page-anchor-category" data-category="Event"></div>');
		
		entityWrapper.append(entityDepiction, entityLabel, pageAnchorContainer);
		entityWrapper.appendTo(entityElement);

		// Fallback to Thing in case of unknown category
		if ( currentData.relatedEntities[key].category == "Person" ) {
			
			if ( cntPerson % entitiesPerPage == 0 ) {
				var pageWrapper = jQuery('<div class="pageWrapper"></div>');
				jQuery('.smn-relation-category[data-category="Person"] .smn-relation-category-entities .smn-scroll-container').append(pageWrapper);
				var paginationItem = jQuery('<div class="smn-pagination-page" data-page="'+ cntPersonPage +'"></div>');
				jQuery('.smn-relation-category[data-category="Person"] .smn-relation-category-pagination').append(paginationItem);
				
				cntPersonPage++;
				
			}
			
			if ( cntPerson % entitiesPerLine == 0 ) {
				var lineWrapper = jQuery('<div class="lineWrapper"></div>');
				jQuery('.smn-relation-category[data-category="Person"] .smn-relation-category-entities .pageWrapper').last().append(lineWrapper);
			}
			
			jQuery('.smn-relation-category[data-category="Person"] .smn-relation-category-entities .pageWrapper').last().children('.lineWrapper').last().append(entityElement);
			cntPerson++;
		} else if ( currentData.relatedEntities[key].category == "Place" ) {
			if ( cntPlace % entitiesPerPage == 0 ) {
				var pageWrapper = jQuery('<div class="pageWrapper"></div>');
				jQuery('.smn-relation-category[data-category="Place"] .smn-relation-category-entities .smn-scroll-container').append(pageWrapper);
				var paginationItem = jQuery('<div class="smn-pagination-page" data-page="'+ cntPlacePage +'"></div>');
				jQuery('.smn-relation-category[data-category="Place"] .smn-relation-category-pagination').append(paginationItem);
				
				cntPlacePage++;
				
			}
			
			if ( cntPlace % entitiesPerLine == 0 ) {
				var lineWrapper = jQuery('<div class="lineWrapper"></div>');
				jQuery('.smn-relation-category[data-category="Place"] .smn-relation-category-entities .pageWrapper').last().append(lineWrapper);
			}
			
			jQuery('.smn-relation-category[data-category="Place"] .smn-relation-category-entities .pageWrapper').last().children('.lineWrapper').last().append(entityElement);
			cntPlace++;
		} else if ( currentData.relatedEntities[key].category == "Event" ) {
			if ( cntEvent % (entitiesPerPage/entitiesPerLine) == 0 ) {
				var pageWrapper = jQuery('<div class="pageWrapper"></div>');
				jQuery('.smn-relation-category[data-category="Event"] .smn-relation-category-entities .smn-scroll-container').append(pageWrapper);
				var paginationItem = jQuery('<div class="smn-pagination-page" data-page="'+ cntEventPage +'"></div>');
				jQuery('.smn-relation-category[data-category="Event"] .smn-relation-category-pagination').append(paginationItem);
				
				cntEventPage++;
				
			}
			
			if ( cntEvent % 1 == 0 ) {
				var lineWrapper = jQuery('<div class="lineWrapper"></div>');
				jQuery('.smn-relation-category[data-category="Event"] .smn-relation-category-entities .pageWrapper').last().append(lineWrapper);
			}
			
			jQuery('.smn-relation-category[data-category="Event"] .smn-relation-category-entities .pageWrapper').last().children('.lineWrapper').last().append(entityElement);
			cntEvent++;
		} else {
			if ( cntThing % entitiesPerPage == 0 ) {
				var pageWrapper = jQuery('<div class="pageWrapper"></div>');
				jQuery('.smn-relation-category[data-category="Thing"] .smn-relation-category-entities .smn-scroll-container').append(pageWrapper);
				var paginationItem = jQuery('<div class="smn-pagination-page" data-page="'+ cntThingPage +'"></div>');
				jQuery('.smn-relation-category[data-category="Thing"] .smn-relation-category-pagination').append(paginationItem);
				
				cntThingPage++;
				
			}
			
			if ( cntThing % entitiesPerLine == 0 ) {
				var lineWrapper = jQuery('<div class="lineWrapper"></div>');
				jQuery('.smn-relation-category[data-category="Thing"] .smn-relation-category-entities .pageWrapper').last().append(lineWrapper);
			}
			
			jQuery('.smn-relation-category[data-category="Thing"] .smn-relation-category-entities .pageWrapper').last().children('.lineWrapper').last().append(entityElement);
			cntThing++;
		}

	}
	
	jQuery('.smn-relation-category-pagination').each(function() {
		elem = jQuery(this);
		elem.children().css('height', (elem.height() / elem.children().length) - 3 + 'px');
	});
	
	jQuery('.smn-pagination-page').click(function() {
		
		var category = jQuery(this).parents('.smn-relation-category').attr('data-category');
		var pageId = jQuery(this).attr('data-page');
		
		goToPage(category, pageId);
		
	});

	jQuery('.smn-relation-category-entities').each(function() {
		jQuery(this).find('.pageWrapper').first().addClass('active');
	});
	jQuery('.smn-relation-category-pagination').each(function() {
		if ( jQuery(this).find('.smn-pagination-page').length > 1 ) {
			jQuery(this).find('.smn-pagination-page').first().addClass('active');
		} else {
			jQuery(this).find('.smn-pagination-page').css('opacity','.3');
		}
	});
	jQuery('.smn-relation-category').each(function() {
		var category = jQuery(this).attr('data-category');
		for (var i=0; i < jQuery(this).find('.pageWrapper').length; i++) {
			focusLine(category, i, 0);
		}
	});
	
	initInterface();

}

var delayTo;
var origin; // origin element
var self; //clone

function initInterface() {

	jQuery('.smn-entity img, .smn-entity-depiction img').centerImage();
	
	jQuery('.smn-entity-depiction img').css('opacity', '1');
	
	jQuery('.lineWrapper').mouseover(function(evt) {
		focusLine( jQuery(this).parents('.smn-relation-category').attr('data-category'), jQuery(this).parent('.pageWrapper').index(), jQuery(this).index() );
	});
	
	jQuery('.smn-entity').mouseover(function() {
		
		clearTimeout(delayTo);
		
		origin = jQuery(this);
		
		delayTo = setTimeout(function() {
			
			clearRaphael();
			jQuery('body > .smn-entity').remove();
			jQuery('#refer-plugin svg').css('z-index', -1);
			jQuery('.smn-entity').removeClass('inactive');
			
			jQuery('.smn-entity').addClass('inactive');
			origin.find('.smn-entity').removeClass('inactive');
			
			pageLineState[origin.parents('.smn-relation-category').attr('data-category')].page = jQuery('.smn-relation-category .pageWrapper.active').index();
			pageLineState[origin.parents('.smn-relation-category').attr('data-category')].line = jQuery('.smn-relation-category .pageWrapper.active .lineWrapper.lineBig').index();
			
			var clone = origin.clone();
			clone.css({
				position: 'fixed',
				top: origin.offset().top - jQuery(window).scrollTop(),
				left: origin.offset().left,
				width: origin.width(),
				height: origin.height(),
				backgroundColor: origin.css('background-color'),
				padding: 3 + 'px',
				cursor: 'pointer',
				'z-index': 100000
			}).appendTo('body');
	        
	        clone.click(function(evt) {  
	            if ( !jQuery(evt.target).hasClass('smn-page-anchor') ) {
	            	var myIri = jQuery(clone).attr('data-iri');
		            loadData(myIri);
	            }
	        	
	        }).mouseenter(function() {
	        	jQuery('body').css('overflow', 'hidden');
	        });
			
			self = clone;
			
			clone.mouseleave(function() {
				
				clearTimeout(delayTo);

				clearRaphael();
				jQuery('body').css('overflow', 'auto');
				jQuery('body > .connectionLabel').remove();
				jQuery('body > .smn-entity').remove();
				jQuery('#refer-plugin svg').css('z-index', -1);
				jQuery('.smn-entity').css('background-color', '');
				jQuery('.smn-entity').removeClass('active');
				jQuery('.smn-entity').removeClass('inactive');
				
				revertPageItems();
				//revertPageLineState();
				
				jQuery('#refer-plugin svg').unbind('mouseover');
				
			});
	        
	        jQuery('#refer-plugin svg').bind('mouseover', function() {
				
				clearTimeout(delayTo);

				clearRaphael();
				jQuery('body > .connectionLabel').remove();
				jQuery('body > .smn-entity').remove();
				jQuery('#refer-plugin svg').css('z-index', -1);
				jQuery('.smn-entity').css('background-color', '');
				jQuery('.smn-entity').removeClass('active');
				jQuery('.smn-entity').removeClass('inactive');
				
				revertPageItems();
				//revertPageLineState();
				
				jQuery('#refer-plugin svg').unbind('mouseover');
				
			});
	        
			jQuery('.smn-result .smn-current-entity').removeClass('active');
			
			// Debugging Helper
			//jQuery('.debugBoundingBox').remove();
			
			var currentSubject = jQuery(self).attr('data-iri');
			var connectedElements = currentData.relatedEntities[currentSubject].connections;
			
			renderRelations(connectedElements);

			jQuery('#refer-plugin svg').css({
				'z-index': 1
				//top: - jQuery(window).scrollTop()
			});

		}, 400);
		


	}).mouseout(function() {
		clearTimeout(delayTo);
	}).click(function() {  
        var myIri = jQuery(this).attr('data-iri');
        loadData(myIri);
    
    });
	
	jQuery('.smn-inner').mouseenter(function() {
		jQuery('body > .smn-entity').remove();
	});
	
	jQuery('.smn-working-indicator').hide();
	resizeRelationBrowser();

}

function loadTimelineData() {
	
	jQuery('.smn-working-indicator').show();
	
	var requestUrl = refer_plugin_url + "proxy.php?services/timeline/x?"; /* DEPLOYMENT */
	
	jQuery.ajax({
		url: requestUrl,
		crossDomain: true
	}).done( function (data) {
		if ( data.error == "1" ) {
			alert("Error in refer Plugin: "+ data.message);
		} else if (!data) {
			alert("refer Plugin: Error loading timeline data.");
		} else {
			originTimelineData = data;
			currentTimelineData = data;
			currentTimelineData = getFilteredItemSet(0.3);
			initTimeline(currentTimelineData);
		}
	}).fail( function (data) {
		var notification = jQuery('<div class="smn-notification">Timeline Data could not be loaded.</div>');
		jQuery('.smn-tabcontent.timeline').append(notification);
	});
}

var timeline;

function initTimeline(data) {
	
	if (timeline) {
		timeline.destroy();
	}
	
	jQuery('.smn-tabcontent.relation-browser .smn-notification').remove();
	
	var container = document.getElementById('smn-timeline');
	
	// Clean Data (remove negative years)
	for ( var i=0; i< data.length; i++ ) {
		if ( data[i].start.substr(0, 1) == "-" ) {
			data.splice(i, 1);
			i--;
		}
	}
	
	var entities = data;
	
	var items = new vis.DataSet(entities);
	var options = {
		height: 580,
		maxHeight: 580,
		showCurrentTime: false,
		min: '0000-01-01',
		max: '2020-01-01',
		padding: 0,
		zoomMax: 1000000000000,
		zoomMin: 100000000000,
		autoResize: false,
		template: function(item) {
			return 	'<div class="timelineItem" data-category="'+ item.category +'" data-id="'+ item.id +'">'+
						'<div class="timelineItemTitle">'+ item.label +'</div>'+
						'<div class="timelineItemRelation">'+ item.relation +'</div>'+
					'</div>';
		}
	};
	timeline = new vis.Timeline(container, items, options);
	
	timeline.on('select', function(items) {
		if (items.items.length > 0) {
			timeline.setOptions({
				height: 360,
				maxHeight: 360
			});
			showTimelineDetails(items.items[0]);
		} else {
			timeline.setOptions({
				height: 580,
				maxHeight: 580
			});
			hideTimelineDetails();
		}
	});
	
	jQuery('#smn-timeline-zoom-out').click(function() {
		zoomTimeline(0.2);
	});
	
	jQuery('#smn-timeline-zoom-in').click(function() {
		zoomTimeline(-0.2);
	});
	
	jQuery('#smn-timeline-move-left').click(function() {
		moveTimeline(0.6);
	});
	
	jQuery('#smn-timeline-move-right').click(function() {
		moveTimeline(-0.6);
	});
	
	jQuery('#smn-timeline-show-all').click(function() {
		jQuery('#smn-timeline-controls-show').children().removeClass('active');
		jQuery(this).addClass('active');
		setTimelineItemLimit(2);
	});
	
	jQuery('#smn-timeline-show-many').click(function() {
		jQuery('#smn-timeline-controls-show').children().removeClass('active');
		jQuery(this).addClass('active');
		setTimelineItemLimit(1);
	});
	
	jQuery('#smn-timeline-show-default').click(function() {
		jQuery('#smn-timeline-controls-show').children().removeClass('active');
		jQuery(this).addClass('active');
		setTimelineItemLimit(0);
	});
	
	jQuery('#smn-timeline-show-few').click(function() {
		jQuery('#smn-timeline-controls-show').children().removeClass('active');
		jQuery(this).addClass('active');
		setTimelineItemLimit(-1);
	});
	

}

function zoomTimeline(percentage) {
    var range = timeline.getWindow();
    var interval = range.end - range.start;

    timeline.setWindow({
        start: range.start.valueOf() - interval * percentage,
        end:   range.end.valueOf()   + interval * percentage
    });
}

function moveTimeline(percentage) {
    var range = timeline.getWindow();
    var interval = range.end - range.start;

    timeline.setWindow({
        start: range.start.valueOf() - interval * percentage,
        end:   range.end.valueOf()   - interval * percentage
    });
}

function setTimelineItemLimit(limit) {
	if (limit == -1) {
		currentTimelineData = getFilteredItemSet(0.5);
	} else if (limit == 0) {
		currentTimelineData = getFilteredItemSet(0.3);
	} else if (limit == 1) {
		currentTimelineData = getFilteredItemSet(0.2);
	} else if (limit == 2) {
		currentTimelineData = originTimelineData;
	}
	timeline.setItems(currentTimelineData);
}

function getFilteredItemSet(scoreLimit) {
	var filteredTimelineData = [];
	for ( var i=0; i < originTimelineData.length; i++ ) {
		if ( originTimelineData[i].priority / originTimelineData.length > scoreLimit ) {
			filteredTimelineData.push(originTimelineData[i]);
		}
	}
	return filteredTimelineData;
}

function showTimelineDetails(entityId) {
	jQuery('.smn-tabcontent.timeline .smn-current-entity .smn-entity-depiction img').attr( "src", "" ).hide();
	jQuery('.smn-tabcontent.timeline .smn-result').show();
	
	var entityData = timeline.itemSet.items[entityId].data;
	
	// Set active entity
	jQuery('.smn-tabcontent.timeline .smn-result').attr('data-category', entityData.category);
	jQuery('.smn-tabcontent.timeline .smn-result').attr("data-iri", entityData.uri);
	jQuery('.smn-tabcontent.timeline .smn-current-entity .smn-entity-depiction img').attr( "src", entityData.image ).show();
	jQuery('.smn-tabcontent.timeline .smn-current-entity .smn-entity-title').text( entityData.label );
	jQuery('.smn-tabcontent.timeline .smn-current-entity .smn-entity-abstract').text( entityData.abstract );
	jQuery('.smn-tabcontent.timeline .smn-current-entity .smn-entity-references a').attr( "href", entityData.uri ).text( 'DBpedia: ' + entityData.label );
    
	// Set Related Articles
	jQuery('.smn-tabcontent.timeline .smn-found-articles-count').text( entityData.relatedArticles.length );
    jQuery('.smn-tabcontent.timeline .smn-found-articles-list').empty();
    
	for ( var i=0; i<entityData.relatedArticles.length; i++ ) {
		var articleNumber = i+1;
		var articleElement = jQuery('<a href="'+ entityData.relatedArticles[i].url +'" title="Read Article" class="smn-article"><span class="smn-article-id">#'+ articleNumber +'</span> '+ entityData.relatedArticles[i].title +'</a>');
		jQuery('.smn-tabcontent.timeline .smn-found-articles-list').append(articleElement);
	}
	
	timeline.redraw();
	window.setTimeout(function() {
		jQuery('.smn-tabcontent.timeline .smn-entity-depiction img').centerImage();
	}, 600);
	
}

function hideTimelineDetails() {
	jQuery('.smn-tabcontent.timeline .smn-result').hide();
	timeline.redraw();
}

var pageLineState = {
	'Person': {
		'page': 0,
		'line': 0
	},
	'Place': {
		'page': 0,
		'line': 0
	},
	'Event': {
		'page': 0,
		'line': 0
	},
	'Thing': {
		'page': 0,
		'line': 0
	}
}

function revertPageLineState() {
	/*
	jQuery('.smn-relation-category').each(function() {
		goToPage(jQuery(this).attr('data-category'), pageLineState[jQuery(this).attr('data-category')].page, pageLineState[jQuery(this).attr('data-category')].line);
	});
	*/
}

function renderRelations(connectedElements, temp) {
	
	clearRaphael();
	jQuery('body > .connectionLabel').remove();
	
	if (!temp) {
		jQuery('body > .smn-entity .smn-page-anchor-category').empty();
	}
	
	for ( var key in connectedElements ) {
		var predicate = connectedElements[key];
		if ( jQuery('.smn-entity[data-iri="'+ key +'"]').length > 0 ) {
			// Element is entity item
			var objectElement = jQuery('.smn-entity[data-iri="'+ key +'"]');
			var idx = objectElement.parent('.lineWrapper').parent('.pageWrapper').index();
            
			var hexColor = rgb2hex( objectElement.css('background-color') );
			
			if ( !objectElement.parent('.lineWrapper').parent('.pageWrapper').hasClass('active') ) {
				// Element in hidden page
				var paginationElement = objectElement.parents('.smn-relation-category').children('.smn-relation-category-pagination').children('.smn-pagination-page[data-page="'+ idx +'"]');
				var hexColor = rgb2hex( objectElement.css('background-color') );
				drawConnections( jQuery(self), paginationElement, 0, {stroke: hexColor, strokeWidth: 2, strokeDasharray: '. '}, 'horizontal', undefined, false, false );
				
				// Append invisible page anchors
				if (!temp && jQuery('body > .smn-entity .smn-page-anchor-category[data-category="'+ objectElement.parents('.smn-relation-category').attr('data-category') +'"]').children('[data-pageid="'+ idx +'"]').length == 0) {
					var anchorCategory = objectElement.parents('.smn-relation-category').attr('data-category');
					var anchorPageIndex = idx;
					if ( anchorCategory == jQuery(origin).parents('.smn-relation-category').attr('data-category') ) {
						var anchorLineIndex = jQuery(origin).parent('.lineWrapper').index();
					} else {
						var anchorLineIndex = objectElement.parent('.lineWrapper').index();
					}
					var anchorItemIndex = objectElement.index();
					var pageAnchor = jQuery('<div class="smn-page-anchor" data-category="'+ anchorCategory +'" data-pageid="'+ anchorPageIndex +'" data-lineid="'+ anchorLineIndex +'" data-itemid="'+ anchorItemIndex +'">+</div>');
					jQuery('body > .smn-entity .smn-page-anchor-category[data-category="'+ anchorCategory +'"]').append(pageAnchor);
				}
					
				
			} else {
				// Element visible in active page
				drawConnections( jQuery(self), objectElement, 10, {stroke: hexColor, strokeWidth: 4}, false, predicate, true, true );
				objectElement.addClass('active');
				objectElement.removeClass('inactive');
				
				if ( jQuery('body > .smn-entity .smn-page-anchor-category[data-category="'+ objectElement.parents('.smn-relation-category').attr('data-category') +'"]').children('[data-pageid="'+ idx +'"]').length == 0 && !temp ) {
					// Append visible page anchors
					var anchorCategory = objectElement.parents('.smn-relation-category').attr('data-category');
					var anchorPageIndex = idx;
					var anchorLineIndex = jQuery(origin).parent('.lineWrapper').index();
					var anchorItemIndex = objectElement.index();
					var pageAnchor = jQuery('<div class="smn-page-anchor active" data-category="'+ anchorCategory +'" data-pageid="'+ anchorPageIndex +'" data-lineid="'+ anchorLineIndex +'" data-itemid="'+ anchorItemIndex +'">+</div>');
					jQuery('body > .smn-entity .smn-page-anchor-category[data-category="'+ anchorCategory +'"]').append(pageAnchor);
				}
				
				
			}
		} else if ( jQuery('.relation-browser .smn-result[data-iri="'+ key +'"] .smn-current-entity').length > 0 ) {
			// Element is current entity
			var objectElement = jQuery('.relation-browser .smn-result[data-iri="'+ key +'"] .smn-current-entity');                                                
				objectElement.addClass('active');
			var hexColor = rgb2hex( objectElement.css('background-color') );
			drawConnections( jQuery(self), objectElement, 10, {stroke: hexColor, strokeWidth: 4}, 'vertical', predicate, false, true );
		}
		
		
	}
	
	// Render second level relations
	
	for ( var i=0; i<jQuery('.smn-entity.active').length; i++ ) {
		
		var newSubjectElement = jQuery('.smn-entity.active').eq(i);
		var newCurrentSubject = newSubjectElement.attr('data-iri');
		
		for ( var newKey in currentData.relatedEntities[newCurrentSubject].connections ) {
			var newPredicate = currentData.relatedEntities[newCurrentSubject].connections[newKey];
			
			var newObjectElement = jQuery('.relation-browser .smn-result[data-iri="'+ newKey +'"] .smn-current-entity');
			
			if ( newObjectElement.length > 0 ) {
				var newHexColor = rgb2hex( newObjectElement.css('background-color') );
				drawConnections( newSubjectElement, newObjectElement, 10, {stroke: newHexColor, strokeWidth: 4}, 'vertical', newPredicate, false );
			}
		}
		
	}
	
	
	if (!temp) {
		// Add Event Listeners to Page Anchors
		jQuery('.smn-page-anchor').hover(function(evt) {
			
			if ( jQuery(this).hasClass('active') ) {
				return false;
			}
			jQuery(this).siblings().removeClass('active');
			jQuery(this).addClass('active');
			
			var conflict = ( jQuery(this).attr('data-category') == origin.parents('.smn-relation-category').attr('data-category') &&  1 == 2 );
			if ( conflict ) {
				swapPageItems(jQuery(this).attr('data-category'), jQuery(this).attr('data-pageid'), jQuery(this).attr('data-lineid'), origin.index());
			}
			
			clearRaphael();
			jQuery('body > .connectionLabel').remove();
			goToPage(jQuery(this).attr('data-category'), jQuery(this).attr('data-pageid'), jQuery(this).attr('data-lineid'), function() {
				//pageAnchor.hide();
				jQuery('.smn-relation-category .smn-entity').css('background-color', '');
				jQuery('.smn-relation-category .smn-entity').removeClass('active');
				clearRaphael();
				jQuery('body > .connectionLabel').remove();
				renderRelations(connectedElements, true);
			});
		}, function(evt) {
			
		});
	}
		
}

function goToPage(category, pageId, lineId ,callback) {
	var paginationElem = jQuery('.smn-relation-category[data-category="'+ category +'"] .smn-pagination-page[data-page="'+ pageId +'"]');
	
	paginationElem.siblings('.smn-pagination-page').removeClass('active');
	paginationElem.addClass('active');
	
	var pageWrappers = jQuery('.smn-relation-category[data-category="'+ category +'"]').find('.pageWrapper');
	
	pageWrappers.removeClass('active');
	pageWrappers.eq( pageId ).addClass('active');
	
	var scrollPosition = - ( (pageWrappers.height() ) * parseInt(pageId) );
	jQuery('.smn-relation-category[data-category="'+ category +'"]').find('.smn-scroll-container').animate({
		top: scrollPosition + 'px'
	}, 200, function() {
		if (lineId) {
			focusLine(category, pageId, lineId);
		} else {
			focusLine(category, pageId, 0);
		}
		
		if (callback) {
			callback.call(this);
		}
	});
}

function swapPageItems(category, pageId, lineId, itemId) {
	
	revertPageItems();
	
	var element1 = jQuery('.smn-relation-category[data-category="'+ category +'"] .pageWrapper').eq(pageId).children('.lineWrapper').eq(lineId).children('.smn-entity').eq(itemId);
	var targetLine = jQuery('.smn-relation-category[data-category="'+ category +'"] .pageWrapper').eq(pageId).children('.lineWrapper').last();
	var element2 = targetLine.children('.smn-entity').eq(0);
	
	if ( element1.attr('data-iri') == origin.attr('data-iri') ) {
		return false;
	}
	
	element1.addClass('smn-swap-origin').after('<div class="smn-swap-origin-placeholder" style="display: none;"></div>');
	element2.addClass('smn-swap-result').after('<div class="smn-swap-result-placeholder" style="display: none;"></div>');
	
	element1.after(element2);
	jQuery('.smn-swap-result-placeholder').before(element1);
	
	//if ('key' in currentData.relatedEntities) {
	//}
}

function revertPageItems() {
	
	jQuery('.smn-swap-origin-placeholder').after( jQuery('.smn-swap-origin') );
	jQuery('.smn-swap-result-placeholder').after( jQuery('.smn-swap-result') );
	
	jQuery('.smn-swap-origin').removeClass('smn-swap-origin');
	jQuery('.smn-swap-result').removeClass('smn-swap-result');
	
	jQuery('.smn-swap-origin-placeholder, .smn-swap-result-placeholder').remove();
}

function focusLine(category, pageIndex, lineIndex) {
	var currentPageElem = jQuery('.smn-relation-category[data-category="'+ category +'"] .pageWrapper').eq(pageIndex);
	currentPageElem.children('.lineWrapper').removeClass('lineBig lineMedium lineSmall');
	var currentLine = jQuery('.smn-relation-category[data-category="'+ category +'"] .pageWrapper').eq(pageIndex).children('.lineWrapper').eq(lineIndex);
	currentLine.addClass('lineBig');
	if ( lineIndex == 0 ) {
		currentLine.next().addClass('lineMedium');
		currentLine.next().next().addClass('lineMedium');
		currentLine.next().next().next().addClass('lineSmall');
		currentLine.next().next().next().next().addClass('lineSmall');
	} else if ( lineIndex == 1 ) {
		currentLine.prev().addClass('lineMedium');
		currentLine.next().addClass('lineMedium');
		currentLine.next().next().addClass('lineSmall');
		currentLine.next().next().next().addClass('lineSmall');
	} else if ( lineIndex == currentPageElem.children('.lineWrapper').length-2 ) {
		currentLine.prev().addClass('lineMedium');
		currentLine.next().addClass('lineMedium');
		currentLine.prev().prev().addClass('lineSmall');
		currentLine.prev().prev().prev().addClass('lineSmall');
	} else if ( lineIndex == currentPageElem.children('.lineWrapper').length-1 ) {
		currentLine.prev().addClass('lineMedium');
		currentLine.prev().prev().addClass('lineMedium');
		currentLine.prev().prev().prev().addClass('lineSmall');
		currentLine.prev().prev().prev().prev().addClass('lineSmall');
	} else {
		currentLine.prev().prev().addClass('lineSmall');
		currentLine.prev().addClass('lineMedium');
		currentLine.next().addClass('lineMedium');
		currentLine.next().next().addClass('lineSmall');
	}
	
	// Apply Entity Element Size
	if ( jQuery(window).width() >= 1200 ) {
		currentPageElem.find('.lineWrapper').not('.lineSmall, .lineMedium, .lineBig').children('.smn-entity').css('height', 18 + 'px');
		currentPageElem.find('.lineWrapper.lineSmall .smn-entity').css('height', 36 + 'px');
		currentPageElem.find('.lineWrapper.lineMedium .smn-entity').css('height', 52 + 'px');
		currentPageElem.find('.lineWrapper.lineBig .smn-entity').css('height', 69 + 'px');
		currentPageElem.find('.lineWrapper.lineBig .smn-entity img').centerImage();
	} else if ( jQuery(window).width() < 1200 && jQuery(window).width() >= 950 ) {
		currentPageElem.find('.lineWrapper').not('.lineSmall, .lineMedium, .lineBig').children('.smn-entity').css('height', 18 + 'px');
		currentPageElem.find('.lineWrapper.lineSmall .smn-entity').css('height', 36 + 'px');
		currentPageElem.find('.lineWrapper.lineMedium .smn-entity').css('height', 52 + 'px');
		currentPageElem.find('.lineWrapper.lineBig .smn-entity').css('height', 69 + 'px');
		currentPageElem.find('.lineWrapper.lineBig .smn-entity img').centerImage();
	} else if ( jQuery(window).width() < 950 && jQuery(window).width() >= 850 ) {
		currentPageElem.find('.lineWrapper').not('.lineSmall, .lineMedium, .lineBig').children('.smn-entity').css('height', 18 + 'px');
		currentPageElem.find('.lineWrapper.lineSmall .smn-entity').css('height', 36 + 'px');
		currentPageElem.find('.lineWrapper.lineMedium .smn-entity').css('height', 52 + 'px');
		currentPageElem.find('.lineWrapper.lineBig .smn-entity').css('height', 69 + 'px');
		currentPageElem.find('.lineWrapper.lineBig .smn-entity img').centerImage();
	} else {
		currentPageElem.find('.lineWrapper').not('.lineSmall, .lineMedium, .lineBig').children('.smn-entity').css('height', 18 + 'px');
		currentPageElem.find('.lineWrapper.lineSmall .smn-entity').css('height', 36 + 'px');
		currentPageElem.find('.lineWrapper.lineMedium .smn-entity').css('height', 52 + 'px');
		currentPageElem.find('.lineWrapper.lineBig .smn-entity').css('height', 69 + 'px');
		currentPageElem.find('.lineWrapper.lineBig .smn-entity img').centerImage();
	}
	
}

function resizeRelationBrowser() {
	
	if ( jQuery(window).width() >= 1600 ) {
		jQuery('#refer-plugin').show();
		
		if ( entitiesPerPage != 28 ) {
			entitiesPerPage = 28;
			entitiesPerLine = 4;
			buildInterface();
			initInterface();
		}
		
		jQuery('.smn-relation-category').css('width','28.5%');
		jQuery('.smn-relation-category.last').css('width','6.8%');
		
		jQuery('.smn-relation-category .smn-entity').css({
			width: '21%'
			//height: 83.9 + 'px'
		});
		
		jQuery('.smn-relation-category.last .smn-entity').css({
			width: '85%'
		});
		
		jQuery('.smn-result .smn-current-entity').css({
			float: '',
			width: '',
			marginBottom: ''
		});
		
		jQuery('.smn-result').css({
			height: ''
		});
		
		jQuery('.smn-result-arrow').css({
			display: ''
		});
		
		jQuery('.smn-result .smn-found-articles').css({
			float: '',
    		width: ''
		});
		
		jQuery('.smn-result .smn-current-entity .smn-entity-depiction').css({
			height: ''
		});
		
		jQuery('.smn-result .smn-current-entity .smn-entity-abstract').css({
			width: ''
		});
		
		jQuery('.smn-result .smn-found-articles .smn-found-articles-list').css({
			height: ''
		});
	} else if ( jQuery(window).width() < 1600 && jQuery(window).width() >= 1400 ) {
		jQuery('#refer-plugin').show();
		
		if ( entitiesPerPage != 21 ) {
			entitiesPerPage = 21;
			entitiesPerLine = 3;
			buildInterface();
			initInterface();
		}
		
		jQuery('.smn-relation-category').css('width','');
		jQuery('.smn-relation-category.last').css('width','');
		
		jQuery('.smn-relation-category .smn-entity').css({
			width: ''
			//height: 76 + 'px'
		});
		
		jQuery('.smn-relation-category.last .smn-entity').css({
			width: '84%'
		});
		
		jQuery('.smn-result .smn-current-entity').css({
			float: '',
			width: '',
			marginBottom: ''
		});
		
		jQuery('.smn-result').css({
			height: ''
		});
		
		jQuery('.smn-result-arrow').css({
			display: ''
		});
		
		jQuery('.smn-result .smn-found-articles').css({
			float: '',
    		width: ''
		});
		
		jQuery('.smn-result .smn-current-entity .smn-entity-depiction').css({
			height: ''
		});
		
		jQuery('.smn-result .smn-current-entity .smn-entity-abstract').css({
			width: ''
		});
		
		jQuery('.smn-result .smn-found-articles .smn-found-articles-list').css({
			height: ''
		});
	} else if ( jQuery(window).width() < 1400 && jQuery(window).width() >= 1200 ) {
		jQuery('#refer-plugin').show();
		
		if ( entitiesPerPage != 21 ) {
			entitiesPerPage = 21;
			entitiesPerLine = 3;
			buildInterface();
			initInterface();
		}
		
		jQuery('.smn-relation-category').css('width','');
		jQuery('.smn-relation-category.last').css('width','');
		
		jQuery('.smn-relation-category .smn-entity').css({
			width: ''
			//height: 68.9 + 'px'
		});
		
		jQuery('.smn-relation-category.last .smn-entity').css({
			width: '84%'
		});
		
		jQuery('.smn-result .smn-current-entity').css({
			float: '',
			width: '',
			marginBottom: ''
		});
		
		jQuery('.smn-result').css({
			height: ''
		});
		
		jQuery('.smn-result-arrow').css({
			display: ''
		});
		
		jQuery('.smn-result .smn-found-articles').css({
			float: '',
    		width: ''
		});
		
		jQuery('.smn-result .smn-current-entity .smn-entity-depiction').css({
			height: ''
		});
		
		jQuery('.smn-result .smn-current-entity .smn-entity-abstract').css({
			width: ''
		});
		
		jQuery('.smn-result .smn-found-articles .smn-found-articles-list').css({
			height: ''
		});
	} else if ( jQuery(window).width() < 1200 && jQuery(window).width() >= 950 ) {
		jQuery('#refer-plugin').show();
		
		if ( entitiesPerPage != 14 ) {
			entitiesPerPage = 14;
			entitiesPerLine = 2;
			buildInterface();
			initInterface();
		}
		
		jQuery('.smn-relation-category').css('width','26%');
		jQuery('.smn-relation-category.last').css('width','13.5%');
		
		jQuery('.smn-relation-category .smn-entity').css({
			width: 44.5 + '%'
			//height: 86 + 'px'
		});
		
		jQuery('.smn-relation-category.last .smn-entity').css({
			width: '87%'
		});
		
		jQuery('.smn-result .smn-current-entity').css({
			float: '',
			width: 57 + '%',
			marginBottom: ''
		});
		
		jQuery('.smn-result').css({
			height: ''
		});
		
		jQuery('.smn-result-arrow').css({
			display: ''
		});
		
		jQuery('.smn-result .smn-found-articles').css({
			float: '',
    		width: ''
		});
		
		jQuery('.smn-result .smn-current-entity .smn-entity-depiction').css({
			height: ''
		});
		
		jQuery('.smn-result .smn-current-entity .smn-entity-abstract').css({
			width: ''
		});
		
		jQuery('.smn-result .smn-found-articles .smn-found-articles-list').css({
			height: ''
		});
	} else if ( jQuery(window).width() < 950 && jQuery(window).width() >= 850 ) {
		jQuery('#refer-plugin').show();
		
		if ( entitiesPerPage != 14 ) {
			entitiesPerPage = 14;
			entitiesPerLine = 2;
			buildInterface();
			initInterface();
		}
		
		jQuery('.smn-relation-category').css('width','26%');
		jQuery('.smn-relation-category.last').css('width','13.5%');
		
		jQuery('.smn-relation-category .smn-entity').css({
			width: 44.5 + '%'
			//height: 76 + 'px'
		});
		
		jQuery('.smn-relation-category.last .smn-entity').css({
			width: '86%'
		});
		
		jQuery('.smn-result .smn-current-entity').css({
			float: '',
			width: 56 + '%',
			marginBottom: ''
		});
		
		jQuery('.smn-result').css({
			height: ''
		});
		
		jQuery('.smn-result-arrow').css({
			display: ''
		});
		
		jQuery('.smn-result .smn-found-articles').css({
			float: '',
    		width: ''
		});
		
		jQuery('.smn-result .smn-current-entity .smn-entity-depiction').css({
			height: ''
		});
		
		jQuery('.smn-result .smn-current-entity .smn-entity-abstract').css({
			width: 75 + '%'
		});
		
		jQuery('.smn-result .smn-found-articles .smn-found-articles-list').css({
			height: ''
		});
	} else if ( jQuery(window).width() < 850 && jQuery(window).width() >= 720 ) {
		jQuery('#refer-plugin').show();
		
		if ( entitiesPerPage != 14 ) {
			entitiesPerPage = 14;
			entitiesPerLine = 2;
			buildInterface();
			initInterface();
		}
		
		jQuery('.smn-relation-category').css('width','26%');
		jQuery('.smn-relation-category.last').css('width','13.5%');
		
		jQuery('.smn-relation-category .smn-entity').css({
			width: 43 + '%'
			//height: 65 + 'px'
		});
		
		jQuery('.smn-relation-category.last .smn-entity').css({
			width: '85%'
		});
		
		jQuery('.smn-result .smn-current-entity').css({
			float: 'none',
			width: 'auto',
			marginBottom: 10 + 'px'
		});
		
		jQuery('.smn-result').css({
			height: 'auto'
		});
		
		jQuery('.smn-result-arrow').css({
			display: 'none'
		});
		
		jQuery('.smn-result .smn-found-articles').css({
			float: 'none',
    		width: 'auto'
		});
		
		jQuery('.smn-result .smn-current-entity .smn-entity-depiction').css({
			height: 157 + 'px'
		});
		
		jQuery('.smn-result .smn-current-entity .smn-entity-abstract').css({
			width: 75 + '%'
		});
		
		jQuery('.smn-result .smn-found-articles .smn-found-articles-list').css({
			height: 97 + 'px'
		});
		
	} else {
		jQuery('#refer-plugin').hide();
	}
		
	var heights = jQuery('.smn-scroll-container .pageWrapper').map(function () {
			return jQuery(this).height();
		}).get(),
		maxHeight = Math.max.apply(null, heights);
	jQuery('.smn-relation-category-entities').height(maxHeight - 6 + 'px');
	
	jQuery('.smn-relation-category-pagination').height(maxHeight - 3 + 'px').each(function() {
		elem = jQuery(this);
		elem.children().css('height', (elem.height() / elem.children().length) - 3 + 'px');
	});
	
	jQuery("#refer-plugin svg").css({
		width: jQuery("#refer-plugin .smn-content").width() + "px",
		height: jQuery("#refer-plugin .smn-content").outerHeight() + "px"
	});
	
	jQuery('#refer-placeholder').height( jQuery('#refer-plugin .smn-content').outerHeight() + 6 );
	//timeline.redraw();
	
}

function rgb2hex(rgb){
	 rgb = rgb.match(/^rgba?[\s+]?\([\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?/i);
	 return (rgb && rgb.length === 4) ? "#" +
			("0" + parseInt(rgb[1],10).toString(16)).slice(-2) +
			("0" + parseInt(rgb[2],10).toString(16)).slice(-2) +
			("0" + parseInt(rgb[3],10).toString(16)).slice(-2) : '';
}